       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLTBLC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      * MAINTENANCE
      * -----------
      * 1994/02/27 Simmons, Created program.
      *
      *****************************************************************
      * Source Member: CBLTBLC1.CBL
      * Copy Files:    CU2SEQB1
      * Calls to:      none...
      *****************************************************************
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     CURS0080 ASCII/CRLF    VARIABLE   00512            *
      *  OUTPUT    MEMCODEA ASCII/CRLF    VARIABLE   00512            *
      *                                                               *
      *****************************************************************
      * This program will load a table with data from a sequential
      * file. The maximum number of table entries for this sample is
      * fifty (50) items.
      *
      * After loading the table it will be sorted using a bubble sort
      * routine to arrange the items in Postal Code sequence.
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT CURS0080-FILE  ASSIGN TO       CURS0080
                  ORGANIZATION IS SEQUENTIAL
                  ACCESS MODE  IS SEQUENTIAL
                  FILE STATUS  IS CURS0080-STATUS.
           SELECT LABEL1X6-FILE  ASSIGN TO       LABEL1X6
                  ORGANIZATION IS SEQUENTIAL
                  ACCESS MODE  IS SEQUENTIAL
                  FILE STATUS  IS LABEL1X6-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  CURS0080-FILE
           DATA RECORD    IS CUST-80-RECORD
           .
       COPY CUST80B1.

       FD  LABEL1X6-FILE
           DATA RECORD    IS LABEL1X6-RECORD
           .
       01  LABEL1X6-RECORD.
           05  LABEL1X6-LINE           PIC X(48).

      *****************************************************************
       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *****************************************************************
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLTBLC1 '.
           05  T2 pic X(34) value 'Example for Table Processing      '.
           05  T3 pic X(10) value ' v08.02.28'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLTBLC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLTBLC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLTBLC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
       01  CURS0080-STATUS.
           05  CURS0080-STATUS-L   pic X.
           05  CURS0080-STATUS-R   pic X.
       01  CURS0080-EOF            pic X       value 'N'.
       01  CURS0080-OPEN-FLAG      pic X       value 'C'.

       01  LABEL1X6-STATUS.
           05  LABEL1X6-STATUS-L   pic X.
           05  LABEL1X6-STATUS-R   pic X.
       01  LABEL1X6-EOF            pic X       value 'N'.
       01  LABEL1X6-OPEN-FLAG      pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.
       01  IO-STATUS-4             pic 9(4)  value 0.
       01  IO-STATUS-4A            redefines IO-STATUS-4 pic X(4).

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLTBLC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
      *    Data-structure for environment variable get routine...
      *****************************************************************
       01  ENV-VAR-NAME            pic X(16)   value SPACES.
       01  ENV-VAR-VALUE           pic X(256)  value SPACES.

       01  ENV-VAR-SIZE            pic 9(3)    value 0.
       01  BUFFER-SIZE             pic 9(3)    value 80.
       01  PTR-01                  pic 9(3)    value 0.
       01  NUMB-01                 pic 9(3)    value 0.

       01  TASK-FLAGS.
           05  TASK-FLAG-BANNER    pic X       value 'Y'.
           05  TASK-FLAG-THANKS    pic X       value 'Y'.
           05  TASK-FLAG-DISPLAY   pic X       value 'Y'.
           05  TASK-FLAG-SYSOUT    pic X       value 'Y'.

       01  CURS0080-TOTAL.
           05  filler      pic X(23)   value 'Source member count is '.
           05  CURS0080-RDR  pic 9(9)    value 0.
           05  filler      pic X       value SPACE.
       01  CURS0080-TOTAL-2.
           05  filler      pic X(23)   value 'Total Lines of Code is '.
           05  TOTAL-LOC   pic 9(9)    value 0.
           05  filler      pic X(20)   value ' Total Hex count is '.
           05  TOTAL-ERR   pic 9(9)    value 0.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  WRK-202                 pic X(202)  value SPACES.
       01  ROUTINE-NAME            pic X(31).

       01  INSERT-COMMA.
           05  FILLER              pic X(2)    value ', '.
           05  WRK-18              pic X(18)   value SPACES.
       01  INSERT-COMMA-X          redefines INSERT-COMMA
                                   pic X(20).

       01  INSERT-SPACE.
           05  FILLER              pic X       value ' '.
           05  WRK-28              pic X(28)   value SPACES.
       01  INSERT-SPACE-X          redefines INSERT-SPACE
                                   pic X(29).

       01  TIX-1                   pic 9(3)    value 0.
       01  TIX-LO                  pic 9(3)    value 0.
       01  TIX-HI                  pic 9(3)    value 0.
       01  TIX-DIFF                pic 9(3)    value 0.
       01  TIX-CURR                pic 9(3)    value 0.
       01  TIX-SWAP-LO             pic 9(3)    value 0.
       01  TIX-SWAP-HI             pic 9(3)    value 0.
       01  NUMBER-OF-ACTIVE-ITEMS  pic 9(3)    value 0.

       COPY LABTABLE.

      *****************************************************************
       PROCEDURE DIVISION.

      *    Perform First-Time processing...
           perform Z-POST-COPYRIGHT

      *    Load the table with data from a file...
           perform LOAD-THE-TABLE

      *    Sort the table by Postal Code
           add TIX-1 to ZERO giving TIX-HI
           add 1 to ZERO giving TIX-LO
           perform SORT-TABLE-BY-POSTAL-CODE

      *    Write the Mailing Labels in Postal Code sequence...
           perform CREATE-LABELS-FROM-TABLE

      *    Possible Abnormal Termination (ABEND)...
           if  APPL-AOK
               if  CURS0080-EOF not = 'Y'
               or  LABEL1X6-EOF not = 'Y'
                   add 16 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  not APPL-AOK
               move 'is ABENDING...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if

      *    End-of-Job...
           if  TASK-FLAG-BANNER = 'Y'
               perform Z-THANK-YOU
           end-if

           GOBACK.

      *****************************************************************
      * <A NAME="CreateLabelsFromTable">CREATE-LABELS-FROM-TABLE</A>    SIMOHTML
      * This routine will access the table sequentially and produce
      * mailing labels in postal code sequence.
      *
       CREATE-LABELS-FROM-TABLE.
           move 'CREATE-LABELS-FROM-TABLE' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING
           add 1 to ZERO giving TIX-1
           perform LABEL1X6-OPEN
             perform until TIX-1 > NUMBER-OF-ACTIVE-ITEMS
      *        Put the First name to Last name separated by a
      *        space on line one (1) of the mailing label.
               move TABL-FIRST-NAME(TIX-1)      to LABEL1X6-LINE
               move TABL-LAST-NAME(TIX-1)      to WRK-28
               inspect LABEL1X6-LINE replacing
                       first '                             '
                       by INSERT-SPACE-X
               perform LABEL1X6-WRITE-WITH-CLEAR

               if  TABL-ADDRESS-1(TIX-1) not = SPACES
                   move TABL-ADDRESS-1(TIX-1)   to LABEL1X6-LINE
                   perform LABEL1X6-WRITE-WITH-CLEAR
               end-if
               if  TABL-ADDRESS-2(TIX-1) not = SPACES
                   move TABL-ADDRESS-2(TIX-1)   to LABEL1X6-LINE
                   perform LABEL1X6-WRITE-WITH-CLEAR
               end-if
      *        Put the City, State and Postal Code on a single line
      *        of the mailing label.
               move TABL-CITY(TIX-1)       to LABEL1X6-LINE
               move TABL-STATE(TIX-1)      to WRK-18
               inspect LABEL1X6-LINE replacing
                       first '                    '
                       by INSERT-COMMA-X
               move TABL-POSTAL-CODE(TIX-1)      to WRK-28
               inspect LABEL1X6-LINE replacing
                       first '                             '
                       by INSERT-SPACE-X
               perform LABEL1X6-WRITE-WITH-CLEAR

               perform LABEL1X6-WRITE-WITH-CLEAR
               perform LABEL1X6-WRITE-WITH-CLEAR
               if  TABL-ADDRESS-1(TIX-1) = SPACES
                   perform LABEL1X6-WRITE-WITH-CLEAR
               end-if
               if  TABL-ADDRESS-2(TIX-1) = SPACES
                   perform LABEL1X6-WRITE-WITH-CLEAR
               end-if
               add 1 to TIX-1
             end-perform
           perform LABEL1X6-CLOSE
           perform Z-ROUTINE-FINISHED
           exit.

      *****************************************************************
      * <A NAME="LoadTheTable">LOAD-THE-TABLE</A>                       SIMOHTML
      * This routine will read a file and load the records into a table
      * in memory. The maximum number of entries in the table is
      * one-hundred (100).
      *
       LOAD-THE-TABLE.
           move 'LOAD-THE-TABLE' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING
           perform CURS0080-OPEN
           move ZERO to TIX-1
           perform until CURS0080-STATUS not = '00'
               perform CURS0080-READ
               if  CURS0080-STATUS = '00'
               and CUST-80-RECORD not = SPACES
                   add 1 to TIX-1
                   move CUST-80-LNAME  to TABL-LAST-NAME(TIX-1)
                   move CUST-80-FNAME  to TABL-FIRST-NAME(TIX-1)
                   move CUST-80-ZIP    to TABL-POSTAL-CODE(TIX-1)
                   move CUST-80-STREET to TABL-ADDRESS-1(TIX-1)
                   move SPACES         to TABL-ADDRESS-2(TIX-1)
                   move CUST-80-CITY   to TABL-CITY(TIX-1)
                   move CUST-80-STATE  to TABL-STATE(TIX-1)
               end-if
           end-perform
           add TIX-1 to ZERO giving NUMBER-OF-ACTIVE-ITEMS
           perform CURS0080-CLOSE
           perform Z-ROUTINE-FINISHED
           exit.

      *****************************************************************
      * <A NAME="SortTableByPostalCode">SORT-TABLE-BY-POSTAL-CODE</A>   SIMOHTML
      * This routine expects TIX-LO to be set to one (1) or point to
      * the first table to be processed. TIX-HI should be set to the
      * number of active entries in the table.
      *
       SORT-TABLE-BY-POSTAL-CODE.
           move 'SORT-TABLE-BY-POSTAL-CODE' to ROUTINE-NAME
           perform Z-ROUTINE-STARTING
           perform until TIX-HI = 0
      *        Prepare for a Low-to-High pass of Table...
               add TIX-LO to ZERO GIVING TIX-CURR
               move 0 to TIX-SWAP-HI
      *        Low-to-High pass of Table, reset High-Limit for Scan...
               perform until TIX-CURR not less than TIX-HI
                   if  TABL-POSTAL-CODE(TIX-CURR) GREATER THAN
                       TABL-POSTAL-CODE(TIX-CURR + 1)
                       move TABLE-OF-CUSTOMERS(TIX-CURR) to WRK-202
                       move TABLE-OF-CUSTOMERS(TIX-CURR + 1)
                         to TABLE-OF-CUSTOMERS(TIX-CURR)
                       move WRK-202 to TABLE-OF-CUSTOMERS(TIX-CURR + 1)
                       add TIX-CURR to ZERO giving TIX-SWAP-HI
                   end-if
                   add 1 to TIX-CURR
               end-perform
      *        Set a new HIGH-LIMIT for table scan...
               add TIX-SWAP-HI to ZERO giving TIX-HI

      *        Prepare for a High-to-Low pass of Table...
               add TIX-HI to ZERO giving TIX-CURR
               move 0 to TIX-LO
      *        High-to-Low pass of Table, reset Low-Limit for Scan...
               perform until TIX-CURR not greater than TIX-LO
                   if  TABL-POSTAL-CODE(TIX-CURR) GREATER THAN
                       TABL-POSTAL-CODE(TIX-CURR + 1)
                       move TABLE-OF-CUSTOMERS(TIX-CURR) to WRK-202
                       move TABLE-OF-CUSTOMERS(TIX-CURR + 1)
                         to TABLE-OF-CUSTOMERS(TIX-CURR)
                       move WRK-202 to TABLE-OF-CUSTOMERS(TIX-CURR + 1)
                       add TIX-CURR to ZERO giving TIX-SWAP-LO
                   end-if
                   subtract 1 from TIX-CURR
               end-perform
      *        Set a new LOW-LIMIT for table scan...
               add TIX-SWAP-LO to ZERO giving TIX-LO
           end-perform
           perform Z-ROUTINE-FINISHED
           exit.

      *****************************************************************
      * I/O ROUTINES FOR LABEL1X6...                                 *
      *****************************************************************
       LABEL1X6-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close LABEL1X6-FILE
           if  LABEL1X6-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               move 'Y' to LABEL1X6-EOF
           else
               move 'LABEL1X6-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LABEL1X6-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       LABEL1X6-WRITE-WITH-CLEAR.
           perform LABEL1X6-WRITE
           move SPACES to LABEL1X6-RECORD
           exit.

      *---------------------------------------------------------------*
       LABEL1X6-WRITE.
           write LABEL1X6-RECORD
           if  LABEL1X6-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  LABEL1X6-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to LABEL1X6-EOF
               else
                   move 'LABEL1X6-Failure-PUT...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move LABEL1X6-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       LABEL1X6-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output LABEL1X6-FILE
           if  LABEL1X6-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to LABEL1X6-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'LABEL1X6-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move LABEL1X6-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR TXTA06512...                                 *
      *****************************************************************
       CURS0080-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CURS0080-FILE
           if  CURS0080-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               move 'Y' to CURS0080-EOF
           else
               move 'CURS0080-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CURS0080-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CURS0080-READ.
           read CURS0080-FILE
           if  CURS0080-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CURS0080-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to CURS0080-EOF
               else
                   move 'CURS0080-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move CURS0080-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CURS0080-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input CURS0080-FILE
           if  CURS0080-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CURS0080-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CURS0080-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CURS0080-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           move SIM-TITLE to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           move SIM-COPYRIGHT to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-4
               move IO-STAT1 to IO-STATUS-4A(1:1)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-4A
               move IO-STATUS to IO-STATUS-4A(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-4A to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if  MESSAGE-TEXT-2 = SPACES
               if  TASK-FLAG-SYSOUT = 'Y'
                   display MESSAGE-BUFFER(1:79)
               else
                   display MESSAGE-BUFFER(1:79) upon console
               end-if
           else
               if  TASK-FLAG-SYSOUT = 'Y'
                   display MESSAGE-BUFFER
               else
                   display MESSAGE-BUFFER upon console
               end-if
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
       Z-ROUTINE-STARTING.
           if  TASK-FLAG-DISPLAY = 'Y'
               move all '-' to MESSAGE-TEXT(1:64)
               move     '*' to MESSAGE-TEXT(1:1)
               move     '*' to MESSAGE-TEXT(64:1)
               perform Z-DISPLAY-MESSAGE-TEXT
               move 'Starting ' to MESSAGE-TEXT
               move ROUTINE-NAME to MESSAGE-TEXT(10:32)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-ROUTINE-FINISHED.
           if  TASK-FLAG-DISPLAY = 'Y'
               move 'Finished ' to MESSAGE-TEXT
               move ROUTINE-NAME to MESSAGE-TEXT(10:32)
               perform Z-DISPLAY-MESSAGE-TEXT
               move SPACES to ROUTINE-NAME
           end-if
           exit.


      *****************************************************************
       Z-THANK-YOU.
           move SIM-THANKS-01 to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           move SIM-THANKS-02 to MESSAGE-BUFFER
           perform Z-DISPLAY-MESSAGE-TEXT
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
